set default_font "-adobe-courier-bold-r-normal--12-120-75-75-m-70-iso8859-1"

odl_module items {

   # make_ghost creates the ghost items on the canvas,
   # and returns a list of their ids.
   param all { make_ghost }
   param new_name ""
   param delete_name delete
   param member_name mem
   param init_name init
   param exit_name exit

   class item {} {
      attr canvas "-"
      attr tags [list]

      attr x 0
      attr y 0

      # Private; don't touch
      attr ids [list]

      method "" moveto {x y}
      method "" moverel {x y}
   }

   class i_ghost { item } {
      attr from "-"
      attr outline red
      attr thick 1

      method "" moverel_contents {x y}

      # Private
      attr start_x 0
      attr start_y 0
   }

   class i_rect { item } {
      attr w 10
      attr h 10
      attr outline black
      attr thick 1
      attr fill none

      attr text ""
      attr text_color black
      attr font $default_font
   }

   class i_txt { item } {
      attr text ""
      attr color black
      attr anchor c
      attr font $default_font
   }

   class i_oval { item } {
      attr w 10
      attr h 10
      attr outline black
      attr thick 1
      attr fill none
      attr centered 1

      attr text ""
      attr text_color black
      attr font $default_font
   }

   class i_line { item } {
      attr to [list]   ; # Relative to the origin of the line
      attr thick 1
      attr outline black
      attr arrow none
   }

   #
   # More complex figures
   #

   class i_disk { item } {
      attr w 10
      attr h 10
      attr outline black
      attr fill grey

      attr text ""
      attr text_color black
      attr font $default_font
   }

   class i_file { item } {
      attr w 10
      attr h 10
      attr outline black
      attr fill white
      
      attr text ""   
      attr text_color black   
      attr font $default_font
   }
}
