#!/usr/bin/wish8.0

source widgets.tcl
source widgets.imp
source items.tcl
source items.imp

###

proc test1 {} {

scrolltext t .f
button .b -text "Quit" -command "its_over"
pack .f -fill both -expand true
pack .b -side top

[t get_text] insert end "Type something here: "

proc its_over {} {
   delete t
   exit
}

}

###

proc test2 {} {

frame .f

scrolltext t1 .f.t1 -want_x 0 -want_y 0
scrolltext t2 .f.t2 -want_x 0 -want_y 1
scrolltext t3 .f.t3 -want_x 1 -want_y 0
scrolltext t4 .f.t4 -want_x 1 -want_y 1

puts "t1 has top frame [t1 get_top]"
puts "t2 has top frame [t2 get_top]"
puts "t3 has top frame [t3 get_top]"
puts "t4 has top frame [t4 get_top]"

[t1 get_text] configure -width 15 -height 15
[t2 get_text] configure -width 15 -height 15
[t3 get_text] configure -width 15 -height 15
[t4 get_text] configure -width 15 -height 15

grid .f.t1 -row 0 -column 0 -sticky news
grid .f.t2 -row 0 -column 1 -sticky news
grid .f.t3 -row 1 -column 0 -sticky news
grid .f.t4 -row 1 -column 1 -sticky news

pack .f -side top -expand true -fill both

button .b -text "Quit" -command "its_over"
pack .b -side top

proc its_over {} {
   delete t1 t2 t3 t4
   exit
}

}

###

proc test3 {} {

# Set up the canvas
scrollcanvas k .f
pack .f -side top -fill both -expand true
global i_global_canvas
set i_global_canvas [k get_canvas]

# Draw some stuff
proc draw1 {} {
   i_rect r1 -x 10 -y 10 -w 50 -h 50 \
      -text "Click\nto\ndelete" \
      -tags {t_r1}
}
proc draw2 {} {
   i_rect r2 -x 100 -y 10 \
      -fill black \
      -tags {t_r2}
   i_txt t2 -x 120 -y 10 -anchor nw -text "DblClick\nto\nmove" -tags {t_r2}
}
proc draw3 {} {
   i_rect r3 -x 200 -y 10 -w 70 -h 70 \
      -fill yellow -outline blue -thick 3 \
      -text "Click\nto\nmove" \
      -tags {t_r3}
}
proc draw4 {} {
   i_rect r4 -x 100 -y 100 -w 50 -h 50 \
      -fill blue -outline red \
      -text "Drag!" -text_color white \
      -tags {t_r4}
}
proc draw5 {} {
   i_oval r5 -x 200 -y 100 -w 50 -h 50 \
      -centered 0 \
      -fill blue -outline red \
      -text "Drag!" -text_color white \
      -tags {t_r5}
}

button .b -text "Quit" -command "its_over"
foreach i { 1 2 3 4 5 } {
   draw$i
   button .br$i -text "Delete$i" -command "delete r$i"
   button .bd$i -text "Draw$i" -command "draw$i"
}
.br2 configure -command "delete r2 t2"
pack .b .br1 .bd1 .br2 .bd2 .br3 .bd3 .br4 .bd4 .br5 .bd5 -side left

$i_global_canvas bind t_r1 <Button-1> "delete r1"
$i_global_canvas bind t_r2 <Double-Button-1> \
   "r2 moveto 10 100 ; t2 moveto 30 100"
$i_global_canvas bind t_r3 <Button-1> "r3 moverel 10 10"
$i_global_canvas bind t_r4 <Button-1> "k startdrag %x %y r4"
$i_global_canvas bind t_r5 <Button-1> \
   "i_ghost g5 -from r5; k startdrag %x %y g5 ghost"

# Some more figures:
i_line lin1 -x 10 -y 160 -thick 3 -tags t_lin1 -arrow both -to {300 0}
$i_global_canvas bind t_lin1 <Button-1> \
   "i_ghost g5 -from lin1; k startdrag %x %y g5 ghost"
i_disk disk1 -x 400 -y 10 -w 50 -h 100 -tags t_disk1
$i_global_canvas bind t_disk1 <Button-1> \
   "k startdrag %x %y disk1"
i_disk disk2 -x 400 -y 130 -w 80 -h 100 -tags t_disk2 \
   -text "Ghost"
$i_global_canvas bind t_disk2 <Button-1> \
   "i_ghost g5 -from disk2; k startdrag %x %y g5 ghost"
i_file file1 -x 500 -y 10 -w 80 -h 40 -tags t_file1 -outline blue
$i_global_canvas bind t_file1 <Button-1> \
   "k startdrag %x %y file1"
i_file file2 -x 500 -y 130 -w 80 -h 20 -tags t_file2 \
   -text "Ghost" -outline blue -text_color blue
$i_global_canvas bind t_file2 <Button-1> \
   "i_ghost g5 -from file2; k startdrag %x %y g5 ghost"


proc its_over {} {
   delete r1 r2 t2 r3 r4 r5
   delete lin1 disk1 disk2 file1 file2

   delete k
   exit
}

}

###

if { [llength $argv] == 0 } {
   test3
} else {
   test[lindex $argv 0]
}
