
# Some useful procs for use with 'tcl_obj'

# Makes data members of $handle available as local variables in a proc body
proc members {handle args} {
   upvar #0 ${handle}_array local_array
   foreach elt $args {
      upvar $elt myvar
      set myvar $local_array($elt)
   }
}

# Writes out a persistent version of an object!
proc make_persistent {handle {outfile stdout}} {
   upvar #0 ${handle}_array local_array
   global odl_types_array

   puts $outfile "$odl_types_array($handle) $handle \\"
   foreach attr [array names local_array] {
      puts $outfile "   -$attr \"$local_array($attr)\" \\"
   }
   puts $outfile ""
}

