# tcl_obj schema for module 'shapes'.
# Look in 'try.tcl' to see how the generated code is used.

odl_module shapes {

   #######
   # Classes

   # Base class for all shapes.
   class shape {} {
      attr id 0
   }

   # Rectangle with a width and height.
   class rect {shape} {
      attr w 10
      attr h 10

      # The 'modifiers' are empty for now.  They are not yet used
      # by obj_tcl.
      method "" perimeter {}
      method "" area {}
      method "" draw { x {y 0} }
   }

   # Square with only a width (the height is the same).
   class square {shape} {
      attr w 10

      method "" perimeter {}
      method "" area {}
      method "" draw { x {y 0} }
   }

   #######
   # Module parameters

   # All classes automatically get a 'print' method.
   param all { print }

   # Constructor names are same as class names.
   param new_name ""

   # Name of the 'delete' proc.
   param delete_name delete

   # Name of the 'member' proc.
   param member_name "mem"

   # Name of 'init' and 'exit' procs, called when objects
   # are constructed/destructed.
   # (Remove the comments, 'make' again, and run 'reg.tcl')
#   param init_name "init"
#   param exit_name "exit"

   # We want debugging output:
   param debug 1
}
